/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.v6 = null;
            this.v7 = null;
            this.wn = 0;
            this.wp = 5;
            this.wo = 0;
            this.wm = 5;
            this.w4 = 5;
            this.w6 = 0;
            this.w5 = 5;
            this.w3 = 0;
            this.abx = null;
            this.ab4 = null;
            this.abv = null;
            this.abw = null;
            this.wy = 0;
            this.xf = 0;
            this.wx = NaN;
            this.xe = NaN;
            this.w0 = NaN;
            this.xh = NaN;
            this.wz = NaN;
            this.xg = NaN;
            this.ww = NaN;
            this.xd = NaN;
            this.ab3 = null;
            this.aca = null;
            this.yp = null;
            this.yt = null;
            this.yr = null;
            this.yv = null;
            this.yk = null;
            this.yl = null;
            this.aby = null;
            this.ab5 = null;
            this.wq = DeviceUtils.g(1);
            this.w7 = DeviceUtils.g(1);
            this.wr = DeviceUtils.g(1);
            this.w8 = DeviceUtils.g(1);
            this.ab0 = null;
            this.ab7 = null;
            this.ab1 = null;
            this.ab8 = null;
            this.ws = DeviceUtils.g(1);
            this.w9 = DeviceUtils.g(1);
            this.wt = DeviceUtils.g(8);
            this.xa = 0;
            this.ab2 = null;
            this.ab9 = null;
            this.wu = DeviceUtils.g(1);
            this.xb = DeviceUtils.g(1);
            this.yq = null;
            this.yu = null;
            this.abz = null;
            this.ab6 = null;
            this.wl = 0;
            this.w2 = 0;
            this.wk = NaN;
            this.w1 = NaN;
            this.wv = 0;
            this.xc = -90;
            this.wg = false;
            this.wh = false;
            this.abq = 1;
            this.act = 1;
            this.abp = 1;
            this.abr = 2;
            this.acr = 0;
            this.acs = 1;
            this.acx = 0;
            this.acy = 0;
            this.we = 4;
            this.wc = 4;
            this.yo = null;
            this.v0 = null;
            this.ys = null;
            this.v1 = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.v4();
                let c = this.v5();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        r9() {
            super.r9();
            let a = this.v4();
            let b = this.v5();
            if (a != null && a.az != null) {
                this.acd = a.az.textColor;
            }
            if (b != null && b.az != null) {
                this.ack = b.az.textColor;
            }
            this.aci = AxisDefaults.j;
            this.acp = AxisDefaults.j;
            this.ace = AxisDefaults.h;
            this.acl = AxisDefaults.h;
            this.ach = AxisDefaults.g;
            this.aco = AxisDefaults.g;
        }
        sz(a, b, c) {
            super.sz(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.abh((d) => d.leftMargin = this.xp);
                    break;
                case "XAxisLabelTopMargin":
                    this.abh((d) => d.topMargin = this.xr);
                    break;
                case "XAxisLabelRightMargin":
                    this.abh((d) => d.rightMargin = this.xq);
                    break;
                case "XAxisLabelBottomMargin":
                    this.abh((d) => d.bottomMargin = this.xo);
                    break;
                case "YAxisLabelLeftMargin":
                    this.abm((d) => d.leftMargin = this.x6);
                    break;
                case "YAxisLabelTopMargin":
                    this.abm((d) => d.topMargin = this.x8);
                    break;
                case "YAxisLabelRightMargin":
                    this.abm((d) => d.rightMargin = this.x7);
                    break;
                case "YAxisLabelBottomMargin":
                    this.abm((d) => d.bottomMargin = this.x5);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.acb = this.u7(this.acd);
                    this.acc = this.u7(this.ack);
                    break;
                case "XAxisLabelTextColor":
                    this.acb = this.u7(this.acd);
                    break;
                case "YAxisLabelTextColor":
                    this.acc = this.u7(this.ack);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.abh((d) => d.textColor = this.acb);
                    break;
                case "ActualYAxisLabelTextColor":
                    this.abm((d) => d.textColor = this.acc);
                    break;
                case "XAxisTitleMargin":
                    this.abj((d) => d.margin = this.x0);
                    break;
                case "YAxisTitleMargin":
                    this.abo((d) => d.margin = this.yh);
                    break;
                case "XAxisTitleLeftMargin":
                    this.abj((d) => d.leftMargin = this.xz);
                    break;
                case "YAxisTitleLeftMargin":
                    this.abo((d) => d.leftMargin = this.yg);
                    break;
                case "XAxisTitleTopMargin":
                    this.abj((d) => d.topMargin = this.x2);
                    break;
                case "YAxisTitleTopMargin":
                    this.abo((d) => d.topMargin = this.yj);
                    break;
                case "XAxisTitleRightMargin":
                    this.abj((d) => d.rightMargin = this.x1);
                    break;
                case "YAxisTitleRightMargin":
                    this.abo((d) => d.rightMargin = this.yi);
                    break;
                case "XAxisTitleBottomMargin":
                    this.abj((d) => d.bottomMargin = this.xy);
                    break;
                case "YAxisTitleBottomMargin":
                    this.abo((d) => d.bottomMargin = this.yf);
                    break;
                case "XAxisTitleTextColor":
                    this.abj((d) => d.textColor = this.acj);
                    break;
                case "YAxisTitleTextColor":
                    this.abo((d) => d.textColor = this.acq);
                    break;
                case "XAxisFormatLabel":
                    this.abf((d) => d.au = this.v8);
                    break;
                case "YAxisFormatLabel":
                    this.abk((d) => d.au = this.v9);
                    break;
            }
        }
        get v8() {
            return this.v6;
        }
        set v8(a) {
            let b = this.v8;
            if (a != b) {
                this.v6 = a;
                this.sw("XAxisFormatLabel", b, this.v8);
            }
        }
        get v9() {
            return this.v7;
        }
        set v9(a) {
            let b = this.v9;
            if (a != b) {
                this.v7 = a;
                this.sw("YAxisFormatLabel", b, this.v9);
            }
        }
        get xp() {
            return this.wn;
        }
        set xp(a) {
            let b = this.xp;
            if (a != b) {
                this.wn = a;
                this.sw("XAxisLabelLeftMargin", b, this.xp);
            }
        }
        get xr() {
            return this.wp;
        }
        set xr(a) {
            let b = this.xr;
            if (a != b) {
                this.wp = a;
                this.sw("XAxisLabelTopMargin", b, this.xr);
            }
        }
        get xq() {
            return this.wo;
        }
        set xq(a) {
            let b = this.xq;
            if (a != b) {
                this.wo = a;
                this.sw("XAxisLabelRightMargin", b, this.xq);
            }
        }
        get xo() {
            return this.wm;
        }
        set xo(a) {
            let b = this.xo;
            if (a != b) {
                this.wm = a;
                this.sw("XAxisLabelBottomMargin", b, this.xo);
            }
        }
        get x6() {
            return this.w4;
        }
        set x6(a) {
            let b = this.x6;
            if (a != b) {
                this.w4 = a;
                this.sw("YAxisLabelLeftMargin", b, this.x6);
            }
        }
        get x8() {
            return this.w6;
        }
        set x8(a) {
            let b = this.x8;
            if (a != b) {
                this.w6 = a;
                this.sw("YAxisLabelTopMargin", b, this.x8);
            }
        }
        get x7() {
            return this.w5;
        }
        set x7(a) {
            let b = this.x7;
            if (a != b) {
                this.w5 = a;
                this.sw("YAxisLabelRightMargin", b, this.x7);
            }
        }
        get x5() {
            return this.w3;
        }
        set x5(a) {
            let b = this.x5;
            if (a != b) {
                this.w3 = a;
                this.sw("YAxisLabelBottomMargin", b, this.x5);
            }
        }
        get acd() {
            return this.abx;
        }
        set acd(a) {
            let b = this.acd;
            if (a != b) {
                this.abx = a;
                this.sw("XAxisLabelTextColor", b, this.acd);
            }
        }
        get ack() {
            return this.ab4;
        }
        set ack(a) {
            let b = this.ack;
            if (a != b) {
                this.ab4 = a;
                this.sw("YAxisLabelTextColor", b, this.ack);
            }
        }
        get acb() {
            return this.abv;
        }
        set acb(a) {
            let b = this.abv;
            if (a != b) {
                this.abv = a;
                this.sw("ActualXAxisLabelTextColor", b, this.acb);
            }
        }
        get acc() {
            return this.abw;
        }
        set acc(a) {
            let b = this.abw;
            if (a != b) {
                this.abw = a;
                this.sw("ActualYAxisLabelTextColor", b, this.acc);
            }
        }
        get x0() {
            return this.wy;
        }
        set x0(a) {
            let b = this.x0;
            if (a != b) {
                this.wy = a;
                this.sw("XAxisTitleMargin", b, this.x0);
            }
        }
        get yh() {
            return this.xf;
        }
        set yh(a) {
            let b = this.yh;
            if (a != b) {
                this.xf = a;
                this.sw("YAxisTitleMargin", b, this.yh);
            }
        }
        get xz() {
            return this.wx;
        }
        set xz(a) {
            let b = this.xz;
            if (a != b) {
                this.wx = a;
                this.sw("XAxisTitleLeftMargin", b, this.xz);
            }
        }
        get yg() {
            return this.xe;
        }
        set yg(a) {
            let b = this.yg;
            if (a != b) {
                this.xe = a;
                this.sw("YAxisTitleLeftMargin", b, this.yg);
            }
        }
        get x2() {
            return this.w0;
        }
        set x2(a) {
            let b = this.x2;
            if (a != b) {
                this.w0 = a;
                this.sw("XAxisTitleTopMargin", b, this.x2);
            }
        }
        get yj() {
            return this.xh;
        }
        set yj(a) {
            let b = this.yj;
            if (a != b) {
                this.xh = a;
                this.sw("YAxisTitleTopMargin", b, this.yj);
            }
        }
        get x1() {
            return this.wz;
        }
        set x1(a) {
            let b = this.x1;
            if (a != b) {
                this.wz = a;
                this.sw("XAxisTitleRightMargin", b, this.x1);
            }
        }
        get yi() {
            return this.xg;
        }
        set yi(a) {
            let b = this.yi;
            if (a != b) {
                this.xg = a;
                this.sw("YAxisTitleRightMargin", b, this.yi);
            }
        }
        get xy() {
            return this.ww;
        }
        set xy(a) {
            let b = this.xy;
            if (a != b) {
                this.ww = a;
                this.sw("XAxisTitleBottomMargin", b, this.xy);
            }
        }
        get yf() {
            return this.xd;
        }
        set yf(a) {
            let b = this.yf;
            if (a != b) {
                this.xd = a;
                this.sw("YAxisTitleBottomMargin", b, this.yf);
            }
        }
        get acj() {
            return this.ab3;
        }
        set acj(a) {
            let b = this.acj;
            if (a != b) {
                this.ab3 = a;
                this.sw("XAxisTitleTextColor", b, this.acj);
            }
        }
        get acq() {
            return this.aca;
        }
        set acq(a) {
            let b = this.acq;
            if (a != b) {
                this.aca = a;
                this.sw("YAxisTitleTextColor", b, this.acq);
            }
        }
        s0(a, b, c) {
            super.s0(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.abh((d) => d.textStyle = this.zd);
                    break;
                case "YAxisLabelTextStyle":
                    this.abm((d) => d.textStyle = this.aai);
                    break;
                case "XAxisTitleTextStyle":
                    this.abj((d) => d.textStyle = this.z1);
                    break;
                case "YAxisTitleTextStyle":
                    this.abo((d) => d.textStyle = this.aa6);
                    break;
            }
        }
        get zd() {
            return this.yp;
        }
        set zd(a) {
            let b = this.zd;
            if (a != b) {
                this.yp = a;
                this.sw("XAxisLabelTextStyle", b, this.zd);
            }
        }
        get aai() {
            return this.yt;
        }
        set aai(a) {
            let b = this.aai;
            if (a != b) {
                this.yt = a;
                this.sw("YAxisLabelTextStyle", b, this.aai);
            }
        }
        get z1() {
            return this.yr;
        }
        set z1(a) {
            let b = this.z1;
            if (a != b) {
                this.yr = a;
                this.sw("XAxisTitleTextStyle", b, this.z1);
            }
        }
        get aa6() {
            return this.yv;
        }
        set aa6(a) {
            let b = this.aa6;
            if (a != b) {
                this.yv = a;
                this.sw("YAxisTitleTextStyle", b, this.aa6);
            }
        }
        abc(a) {
            this.aa9(a, (b) => b.leftMargin = this.xp);
            this.aa9(a, (b) => b.topMargin = this.xr);
            this.aa9(a, (b) => b.rightMargin = this.xq);
            this.aa9(a, (b) => b.bottomMargin = this.xo);
            this.aa9(a, (b) => b.textColor = this.acb);
            this.aba(a, (b) => b.textColor = this.acj);
            this.aba(a, (b) => b.leftMargin = this.xz);
            this.aba(a, (b) => b.topMargin = this.x2);
            this.aba(a, (b) => b.rightMargin = this.x1);
            this.aba(a, (b) => b.bottomMargin = this.xy);
            this.aa9(a, (b) => b.textStyle = this.zd);
            this.aba(a, (b) => b.textStyle = this.z1);
        }
        abe(a) {
            this.aa9(a, (b) => b.leftMargin = this.x6);
            this.aa9(a, (b) => b.topMargin = this.x8);
            this.aa9(a, (b) => b.rightMargin = this.x7);
            this.aa9(a, (b) => b.bottomMargin = this.x5);
            this.aa9(a, (b) => b.textColor = this.acc);
            this.aba(a, (b) => b.textColor = this.acq);
            this.aba(a, (b) => b.leftMargin = this.yg);
            this.aba(a, (b) => b.topMargin = this.yj);
            this.aba(a, (b) => b.rightMargin = this.yi);
            this.aba(a, (b) => b.bottomMargin = this.yf);
            this.aa9(a, (b) => b.textStyle = this.aai);
            this.aba(a, (b) => b.textStyle = this.aa6);
        }
        th(a) {
            let b = this.bc(a);
            let c = this.c1(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            c.name = this.oe(a);
            c.title = this.of(a, b);
            this.dataChart.series.add(c);
        }
        abf(a) {
            this.abg(a, null);
        }
        abg(a, b) {
            a(this.v4());
        }
        abl(a, b) {
            a(this.v5());
        }
        abk(a) {
            this.abl(a, true);
        }
        rt(a, b) {
            this.abf(a);
            this.abl(a, b);
        }
        abj(a) {
            this.aba(this.v4(), a);
        }
        abo(a) {
            this.aba(this.v5(), a);
        }
        abm(a) {
            this.aa9(this.v5(), a);
        }
        abh(a) {
            this.aa9(this.v4(), a);
        }
        xi(a) {
            let b = this.v4();
            return b.ej(a, new ScalerParams(1, this.vf, this.ve, b.ch));
        }
        xk(a) {
            let b = this.v4();
            return b.em(a, new ScalerParams(1, this.vf, this.ve, b.ch));
        }
        xj(a) {
            let b = this.v5();
            return b.ej(a, new ScalerParams(1, this.vf, this.ve, b.ch));
        }
        xl(a) {
            let b = this.v5();
            return b.em(a, new ScalerParams(1, this.vf, this.ve, b.ch));
        }
        te(a) {
            super.te(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.v4();
                let c = this.v5();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static yy(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        r4(a) {
            super.r4(a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.v4());
                this.dataChart.axes.add(this.v5());
            }
        }
        abb(a) {
            if (a != null && this.j8 != null && a.fl == null) {
                a.provideRenderer(this.j8);
            }
            a.jw = this.ace;
            a.er = this.xs;
            a.jx = this.acf;
            a.eu = this.xt;
            a.jz = this.ach;
            a.fg = this.xu;
            a.jy = this.acg;
            a.fh = this.xv;
            a.j0 = this.aci;
            a.fi = this.xw;
            a.c4 = true;
            a.cu = this.gb;
            a.cw = this.gb;
            let b = a == this.v4();
            if (b) {
                a.g6 = this.zs;
            }
            a.f0 = this.ym;
            a.gg = this.y4;
            a.ah = this.v2;
            this.aa9(a, (c) => c.angle = this.xn);
            this.aa9(a, (c) => {
                if (c.extent != this.xm) {
                    c.extent = this.xm;
                }
            });
            this.aa9(a, (c) => c.horizontalAlignment = this.abs);
            this.aa9(a, (c) => c.verticalAlignment = this.acu);
            this.aa9(a, (c) => c.visibility = this.acz);
            this.aa9(a, (c) => c.location = this.wa(this.wd));
            this.aba(a, (c) => c.horizontalAlignment = this.abt);
            this.aba(a, (c) => c.angle = this.xx);
            this.abc(a);
        }
        abd(a) {
            if (a == null) {
                return;
            }
            if (this.j8 != null && a.fl == null) {
                a.provideRenderer(this.j8);
            }
            a.cu = this.gb;
            a.cw = this.gb;
            this.aa9(a, (b) => b.angle = this.x4);
            this.aa9(a, (b) => {
                if (b.extent != this.x3) {
                    b.extent = this.x3;
                }
            });
            this.aa9(a, (b) => b.horizontalAlignment = this.abu);
            this.aa9(a, (b) => b.verticalAlignment = this.acv);
            this.aa9(a, (b) => b.visibility = this.ac0);
            this.aa9(a, (b) => b.location = this.wb(this.wf));
            this.aba(a, (b) => b.verticalAlignment = this.acw);
            this.aba(a, (b) => b.angle = this.ye);
            a.jw = this.acl;
            a.er = this.x9;
            a.jx = this.acm;
            a.eu = this.ya;
            a.jz = this.aco;
            a.fg = this.yb;
            a.jy = this.acn;
            a.fh = this.yc;
            a.j0 = this.acp;
            a.fi = this.yd;
            let b = a == this.v5();
            if (b) {
                a.g6 = this.aax;
            }
            a.gg = this.z9;
            a.ah = this.v3;
            this.abe(a);
        }
        r1() {
            super.r1();
            this.abb(this.v4());
            this.abd(this.v5());
        }
        aa9(a, b) {
            if (a == null) {
                return;
            }
            if (a.az == null) {
                a.az = new AxisLabelSettings();
                a.az.angle = a.d5();
                a.az.bottomMargin = a.d6();
                a.az.leftMargin = a.d7();
                a.az.rightMargin = a.d8();
                a.az.topMargin = a.d9();
                a.az.horizontalAlignment = a.jr();
                a.az.location = a.a0();
                a.az.verticalAlignment = a.kk();
            }
            b(a.az);
        }
        aba(a, b) {
            if (a == null) {
                return;
            }
            if (a.bf == null) {
                a.bf = new TitleSettings();
                a.bf.bottomMargin = a.eb();
                a.bf.leftMargin = a.ec();
                a.bf.rightMargin = a.ed();
                a.bf.topMargin = a.ee();
                a.bf.location = a.a1();
                a.bf.angle = a.ea();
                a.bf.horizontalAlignment = a.js();
                a.bf.verticalAlignment = a.kl();
            }
            b(a.bf);
        }
        sw(a, b, c) {
            super.sw(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.abh((d) => d.angle = this.xn);
                    break;
                case "YAxisLabelAngle":
                    this.abm((d) => d.angle = this.x4);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.abh((d) => d.horizontalAlignment = this.abs);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.abm((d) => d.horizontalAlignment = this.abu);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.abh((d) => d.verticalAlignment = this.acu);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.abm((d) => d.verticalAlignment = this.acv);
                    break;
                case "XAxisLabelVisibility":
                    this.abh((d) => d.visibility = this.acz);
                    break;
                case "YAxisLabelVisibility":
                    this.abm((d) => d.visibility = this.ac0);
                    break;
                case "XAxisLabel":
                    this.abf((d) => d.f0 = this.ym);
                    break;
                case "YAxisLabel":
                    this.abk((d) => d.f0 = this.yn);
                    break;
                case "XAxisLabelFormat":
                    this.abf((d) => d.gg = this.y4);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.abf((d) => d.ah = this.v2);
                    break;
                case "YAxisLabelFormat":
                    this.abk((d) => d.gg = this.z9);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.abk((d) => d.ah = this.v3);
                    break;
                case "XAxisTitleAngle":
                    this.abj((d) => d.angle = this.xx);
                    break;
                case "YAxisTitleAngle":
                    this.abo((d) => d.angle = this.ye);
                    break;
                case "XAxisTitleAlignment":
                    this.abj((d) => d.horizontalAlignment = this.abt);
                    break;
                case "YAxisTitleAlignment":
                    this.abo((d) => d.verticalAlignment = this.acw);
                    break;
                case "XAxisTitle":
                    this.abf((d) => d.g6 = this.zs);
                    break;
                case "YAxisTitle":
                    this.abl((d) => d.g6 = this.aax, false);
                    break;
                case "XAxisMajorStroke":
                    this.abg((d) => d.jw = this.ace, a);
                    break;
                case "YAxisMajorStroke":
                    this.abk((d) => d.jw = this.acl);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.abg((d) => d.er = this.xs, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.abk((d) => d.er = this.x9);
                    break;
                case "XAxisMinorStroke":
                    this.abf((d) => d.jx = this.acf);
                    break;
                case "YAxisMinorStroke":
                    this.abk((d) => d.jx = this.acm);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.abf((d) => d.eu = this.xt);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.abk((d) => d.eu = this.ya);
                    break;
                case "XAxisTickLength":
                    this.abf((d) => d.fh = this.xv);
                    break;
                case "YAxisTickLength":
                    this.abk((d) => d.fh = this.yc);
                    break;
                case "XAxisTickStroke":
                    this.abf((d) => d.j0 = this.aci);
                    break;
                case "YAxisTickStroke":
                    this.abk((d) => d.j0 = this.acp);
                    break;
                case "XAxisTickStrokeThickness":
                    this.abf((d) => d.fi = this.xw);
                    break;
                case "YAxisTickStrokeThickness":
                    this.abk((d) => d.fi = this.yd);
                    break;
                case "XAxisStroke":
                    this.abf((d) => d.jz = this.ach);
                    break;
                case "YAxisStroke":
                    this.abk((d) => d.jz = this.aco);
                    break;
                case "XAxisStrokeThickness":
                    this.abf((d) => d.fg = this.xu);
                    break;
                case "YAxisStrokeThickness":
                    this.abk((d) => d.fg = this.yb);
                    break;
                case "XAxisExtent":
                    this.abh((d) => d.extent = this.xm);
                    break;
                case "YAxisExtent":
                    this.abm((d) => d.extent = this.x3);
                    break;
                case "XAxisStrip":
                    this.abf((d) => d.jy = this.acg);
                    break;
                case "YAxisStrip":
                    this.abk((d) => d.jy = this.acn);
                    break;
                case "XAxisInverted":
                    this.abf((d) => d.ch = this.wi);
                    break;
                case "YAxisInverted":
                    this.abk((d) => d.ch = this.wj);
                    break;
                case "YAxisLabelLocation":
                    this.abn();
                    break;
                case "XAxisLabelLocation":
                    this.abi();
                    break;
            }
        }
        abn() {
            let a = this.wb(this.wf);
            if (a == 2 || a == 7) {
                this.abu = 2;
            }
            else {
                this.abu = 0;
            }
            this.abm((b) => b.location = a);
        }
        abi() {
            let a = this.wa(this.wd);
            if (a == 1 || a == 5) {
                this.acu = 0;
            }
            else {
                this.acu = 2;
            }
            this.abh((b) => b.location = a);
        }
        wb(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.b1 == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        wa(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get ym() {
            return this.yk;
        }
        set ym(a) {
            let b = this.ym;
            if (a != b) {
                this.yk = a;
                this.sw("XAxisLabel", b, this.ym);
            }
        }
        get yn() {
            return this.yl;
        }
        set yn(a) {
            let b = this.yn;
            if (a != b) {
                this.yl = a;
                this.sw("YAxisLabel", b, this.yn);
            }
        }
        get ace() {
            return this.aby;
        }
        set ace(a) {
            let b = this.ace;
            if (a != b) {
                this.aby = a;
                this.sw("XAxisMajorStroke", b, this.ace);
            }
        }
        get acl() {
            return this.ab5;
        }
        set acl(a) {
            let b = this.acl;
            if (a != b) {
                this.ab5 = a;
                this.sw("YAxisMajorStroke", b, this.acl);
            }
        }
        get xs() {
            return this.wq;
        }
        set xs(a) {
            let b = this.xs;
            if (a != b) {
                this.wq = a;
                this.sw("XAxisMajorStrokeThickness", b, this.xs);
            }
        }
        get x9() {
            return this.w7;
        }
        set x9(a) {
            let b = this.x9;
            if (a != b) {
                this.w7 = a;
                this.sw("YAxisMajorStrokeThickness", b, this.x9);
            }
        }
        get xt() {
            return this.wr;
        }
        set xt(a) {
            let b = this.xt;
            if (a != b) {
                this.wr = a;
                this.sw("XAxisMinorStrokeThickness", b, this.xt);
            }
        }
        get ya() {
            return this.w8;
        }
        set ya(a) {
            let b = this.ya;
            if (a != b) {
                this.w8 = a;
                this.sw("YAxisMinorStrokeThickness", b, this.ya);
            }
        }
        get acg() {
            return this.ab0;
        }
        set acg(a) {
            let b = this.acg;
            if (a != b) {
                this.ab0 = a;
                this.sw("XAxisStrip", b, this.acg);
            }
        }
        get acn() {
            return this.ab7;
        }
        set acn(a) {
            let b = this.acn;
            if (a != b) {
                this.ab7 = a;
                this.sw("YAxisStrip", b, this.acn);
            }
        }
        get ach() {
            return this.ab1;
        }
        set ach(a) {
            let b = this.ach;
            if (a != b) {
                this.ab1 = a;
                this.sw("XAxisStroke", b, this.ach);
            }
        }
        get aco() {
            return this.ab8;
        }
        set aco(a) {
            let b = this.aco;
            if (a != b) {
                this.ab8 = a;
                this.sw("YAxisStroke", b, this.aco);
            }
        }
        get xu() {
            return this.ws;
        }
        set xu(a) {
            let b = this.xu;
            if (a != b) {
                this.ws = a;
                this.sw("XAxisStrokeThickness", b, this.xu);
            }
        }
        get yb() {
            return this.w9;
        }
        set yb(a) {
            let b = this.yb;
            if (a != b) {
                this.w9 = a;
                this.sw("YAxisStrokeThickness", b, this.yb);
            }
        }
        get xv() {
            return this.wt;
        }
        set xv(a) {
            let b = this.xv;
            if (a != b) {
                this.wt = a;
                this.sw("XAxisTickLength", b, this.xv);
            }
        }
        get yc() {
            return this.xa;
        }
        set yc(a) {
            let b = this.yc;
            if (a != b) {
                this.xa = a;
                this.sw("YAxisTickLength", b, this.yc);
            }
        }
        get aci() {
            return this.ab2;
        }
        set aci(a) {
            let b = this.aci;
            if (a != b) {
                this.ab2 = a;
                this.sw("XAxisTickStroke", b, this.aci);
            }
        }
        get acp() {
            return this.ab9;
        }
        set acp(a) {
            let b = this.acp;
            if (a != b) {
                this.ab9 = a;
                this.sw("YAxisTickStroke", b, this.acp);
            }
        }
        get xw() {
            return this.wu;
        }
        set xw(a) {
            let b = this.xw;
            if (a != b) {
                this.wu = a;
                this.sw("XAxisTickStrokeThickness", b, this.xw);
            }
        }
        get yd() {
            return this.xb;
        }
        set yd(a) {
            let b = this.yd;
            if (a != b) {
                this.xb = a;
                this.sw("YAxisTickStrokeThickness", b, this.yd);
            }
        }
        get zs() {
            return this.yq;
        }
        set zs(a) {
            let b = this.zs;
            if (a != b) {
                this.yq = a;
                this.sw("XAxisTitle", b, this.zs);
            }
        }
        get aax() {
            return this.yu;
        }
        set aax(a) {
            let b = this.aax;
            if (a != b) {
                this.yu = a;
                this.sw("YAxisTitle", b, this.aax);
            }
        }
        get acf() {
            return this.abz;
        }
        set acf(a) {
            let b = this.acf;
            if (a != b) {
                this.abz = a;
                this.sw("XAxisMinorStroke", b, this.acf);
            }
        }
        get acm() {
            return this.ab6;
        }
        set acm(a) {
            let b = this.acm;
            if (a != b) {
                this.ab6 = a;
                this.sw("YAxisMinorStroke", b, this.acm);
            }
        }
        get xn() {
            return this.wl;
        }
        set xn(a) {
            let b = this.xn;
            if (a != b) {
                this.wl = a;
                this.sw("XAxisLabelAngle", b, this.xn);
            }
        }
        get x4() {
            return this.w2;
        }
        set x4(a) {
            let b = this.x4;
            if (a != b) {
                this.w2 = a;
                this.sw("YAxisLabelAngle", b, this.x4);
            }
        }
        get xm() {
            return this.wk;
        }
        set xm(a) {
            let b = this.xm;
            if (a != b) {
                this.wk = a;
                this.sw("XAxisExtent", b, this.xm);
            }
        }
        get x3() {
            return this.w1;
        }
        set x3(a) {
            let b = this.x3;
            if (a != b) {
                this.w1 = a;
                this.sw("YAxisExtent", b, this.x3);
            }
        }
        get xx() {
            return this.wv;
        }
        set xx(a) {
            let b = this.xx;
            if (a != b) {
                this.wv = a;
                this.sw("XAxisTitleAngle", b, this.xx);
            }
        }
        get ye() {
            return this.xc;
        }
        set ye(a) {
            let b = this.ye;
            if (a != b) {
                this.xc = a;
                this.sw("YAxisTitleAngle", b, this.ye);
            }
        }
        get wi() {
            return this.wg;
        }
        set wi(a) {
            let b = this.wi;
            if (a != b) {
                this.wg = a;
                this.sw("XAxisInverted", b, this.wi);
            }
        }
        get wj() {
            return this.wh;
        }
        set wj(a) {
            let b = this.wj;
            if (a != b) {
                this.wh = a;
                this.sw("YAxisInverted", b, this.wj);
            }
        }
        get abt() {
            return this.abq;
        }
        set abt(a) {
            let b = this.abt;
            if (a != b) {
                this.abq = a;
                this.sw("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abt));
            }
        }
        get acw() {
            return this.act;
        }
        set acw(a) {
            let b = this.acw;
            if (a != b) {
                this.act = a;
                this.sw("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acw));
            }
        }
        get abs() {
            return this.abp;
        }
        set abs(a) {
            let b = this.abs;
            if (a != b) {
                this.abp = a;
                this.sw("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abs));
            }
        }
        get_abu() {
            return this.abr;
        }
        set_abu(a) {
            let b = this.abu;
            if (a != b) {
                this.abr = a;
                this.sw("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abu));
            }
        }
        get abu() {
            return this.get_abu();
        }
        set abu(a) {
            this.set_abu(a);
        }
        get acu() {
            return this.acr;
        }
        set acu(a) {
            let b = this.acu;
            if (a != b) {
                this.acr = a;
                this.sw("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acu));
            }
        }
        get acv() {
            return this.acs;
        }
        set acv(a) {
            let b = this.acv;
            if (a != b) {
                this.acs = a;
                this.sw("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acv));
            }
        }
        get acz() {
            return this.acx;
        }
        set acz(a) {
            let b = this.acz;
            if (a != b) {
                this.acx = a;
                this.sw("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.acz));
            }
        }
        get ac0() {
            return this.acy;
        }
        set ac0(a) {
            let b = this.ac0;
            if (a != b) {
                this.acy = a;
                this.sw("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ac0));
            }
        }
        get_wf() {
            return this.we;
        }
        set_wf(a) {
            let b = this.wf;
            if (a != b) {
                this.we = a;
                this.sw("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.wf));
            }
        }
        get wf() {
            return this.get_wf();
        }
        set wf(a) {
            this.set_wf(a);
        }
        get_wd() {
            return this.wc;
        }
        set_wd(a) {
            let b = this.wd;
            if (a != b) {
                this.wc = a;
                this.sw("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.wd));
            }
        }
        get wd() {
            return this.get_wd();
        }
        set wd(a) {
            this.set_wd(a);
        }
        get y4() {
            return this.yo;
        }
        set y4(a) {
            let b = this.yo;
            if (a != b) {
                this.yo = a;
                this.sw("XAxisLabelFormat", b, this.yo);
            }
        }
        get v2() {
            return this.v0;
        }
        set v2(a) {
            let b = this.v0;
            if (a != b) {
                this.v0 = a;
                this.sw("XAxisLabelFormatSpecifiers", b, this.v0);
            }
        }
        get z9() {
            return this.ys;
        }
        set z9(a) {
            let b = this.ys;
            if (a != b) {
                this.ys = a;
                this.sw("YAxisLabelFormat", b, this.ys);
            }
        }
        get v3() {
            return this.v1;
        }
        set v3(a) {
            let b = this.v1;
            if (a != b) {
                this.v1 = a;
                this.sw("YAxisLabelFormatSpecifiers", b, this.v1);
            }
        }
    }
    XYChart.$t = /*@__PURE__*/ markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
